<?php


namespace Controller;

use Traits\TResponse;
use Util\InstanceProvider;
use Util\Utilities;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class IssueLabels
{
    use TResponse;

    /**
     * @var \Service\IssueLabels
     */
    private $issueLabelsService;

    public function __construct(\Service\IssueLabels $issueLabelsService)
    {
        $this->issueLabelsService = $issueLabelsService;
    }

    public function findMyIssueLabels(Request $request, Response $response)
    {
        try {
            $actions = $this->issueLabelsService->findMyIssueLabels();
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findProjectProductAndMeeting(Request $request, Response $response)
    {
        try {
            $data = $this->issueLabelsService->findProjectProductAndMeeting();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveIssueLabels(Request $request, Response $response)
    {
        try {
            $param = $request->getParameters();
            $id = !empty($param['ID']) ? $param['ID'] : null;
            $description = $request->getParameter('DESCRIPTION');
            $idproject = !empty($param['IDPROJECT']) ? $param['IDPROJECT'] : null;
            $actions = $this->issueLabelsService->saveIssueLabels($id, $description, $idproject);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function removeIssueLabels(Request $request, Response $response)
    {
        try {
            $rows = $request->getParameter('ROWS');
            $actions = $this->issueLabelsService->removeIssueLabels($rows);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveDescricaoGrid(Request $request, Response $response)
    {
        try {
            $rows = $request->getParameter('ROWS');
            $actions = $this->issueLabelsService->saveDescricaoGrid($rows);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}