<?php


namespace Controller;

use Traits\TResponse;
use Util\InstanceProvider;
use Zeedhi\Framework\DTO;
use Service\Project as ProjectService;

class Project
{
    use TResponse;

    /**
     * @var ProjectService
     */
    private $projectService;

    public function __construct(ProjectService $projectService)
    {
        $this->projectService = $projectService;
    }

    public function findProjectsByOperador(DTO\Request $request, DTO\Response $response)
    {
        try {
            $projects = $this->projectService->findProjectsByOperador();
            $this->sendResponse($projects, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }

    public function modelProjectForFilterTaskTracking(DTO\Request $request, DTO\Response $response){
        try{
            $projects = $this->projectService->findModelProjectForFilterTaskTracking();
            $this->sendResponse($projects, 200);
        } catch (\Exception $e){
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }
    
    public function findProjectTypesToIssue(DTO\Request $request, DTO\Response $response) {
        try {
            $projectTypes = $this->projectService->findProjectTypesToIssue();
            $this->sendResponse($projectTypes, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
