<?php

namespace Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class ProjectType
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * ProjectType constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findIssueFramingProjectType($issueStatusId)
    {

        $query = <<<SQL
          SELECT TPT.ID, PRT.LABEL,TPT.PROJECT_TYPE_ID,PRT.LABEL AS LABEL_FORM
            FROM TASK_TYPE_PROJECT_TYPE TPT
            JOIN PROJECT_TYPE PRT ON (PRT.ID = TPT.PROJECT_TYPE_ID)
           WHERE TPT.STATUS = 'A'
             AND TPT.TASK_TYPE_ID = :issueStatusId
       ORDER BY TPT.ID ASC
SQL;
        $params = array(
            'issueStatusId' => $issueStatusId
        );

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }

    public function findProjectTypes($organizationId){

        $query = <<<SQL
          SELECT * FROM (
		   SELECT PRT.ID, PRT.LABEL
			 FROM PROJECT_TYPE PRT
			WHERE PRT.ORGANIZATION = :ORGANIZATION_ID)
			WHERE 1 = 1
         ORDER BY LABEL
SQL;
        $params = array(
            'ORGANIZATION_ID' => $organizationId,
        );
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }
}
